#!/usr/bin/env python3

"""This script generates `pydantic`_ custom resource (CR) data models.

Data models are generated from kubernetes custom resource definition's (CRD)
`OpenAPI v3 schema`_. In general, the OpenAPI v3
schema is used for CRD validation under CRD.Spec.Validation.OpenAPIV3Schema.
The language is essentially JSON Schema. OpenAPI builds on that, and we use that
dialect to be able to reuse the specs for models generation.

Script uses and slightly enhances functionality of `datamodel-code-generator`_ library.
Pydantic CR data models are saved as a python module. The name of the module as well
as the name of the parent class are determined based on CR's **kind** name.

See script's help for further information:

.. code-block:: bash
   model --help

.. _pydantic: https://pydantic-docs.helpmanual.io/
.. _OpenAPI v3 schema :https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.0.0.md#schemaObject  # noqa: E501
.. _datamodel-code-generator: https://github.com/koxudaxi/datamodel-code-generator/
"""

import json
from pathlib import Path
from typing import Generator

import click
import yaml
from datamodel_code_generator import Error as DataModelGeneratorError
from datamodel_code_generator import InputFileType, generate
from loguru import logger

HEADER_MSGS = (
    "# DO NOT EDIT this file by hand!",
    "# It is generated from corresponding Open API schema.",
    "# Visit `yaookctl/commands/generate/model.py` for further details.",
)
METADATA_SCHEMA = {
    "type": "object",
    "properties": {
        "name": {
            "type": "string",
        },
        "namespace": {
            "type": "string",
        },
    },
}
DEFAULT_MODELS_DIR = Path("k8s_capi_provider") / "src" / "models"
DEFAULT_CRD_FILE = Path("chart") / "crds" / "clusters.yaml"


def get_objs(crd: str) -> Generator[dict, None, None]:
    """Get resource object from given yaml file.

    Args:
        crd (str): Yaml file with CRD.

    Yields:
        dict: Resource object.

    Raises:
        yaml.YAMLError: If CRD does not have an expected format.
    """
    try:
        with open(crd) as fd:
            yield from yaml.safe_load_all(fd)
    except yaml.YAMLError as e:
        logger.error(f"CRD does not have an expected format: {e}")
        exit(1)


def get_model_path(obj: dict, output: Path) -> Path:
    """Get model path.

    Args:
        obj (dict): Resource which will be saved as model.
        output (Path): Resource model base path.

    Returns:
        Path: Model path.
    """
    return output / str(obj["spec"]["names"]["kind"].lower() + ".py")


def get_class_name(obj: dict) -> str:
    """Get resource base class name.

    Args:
        obj (dict): Resource which will be saved as model.

    Returns:
        str: Class name.
    """
    return obj["spec"]["names"]["kind"]


def get_schema(obj: dict) -> str:
    """Get resource OpenAPI v3 schema.

    Args:
        obj (dict): Resource which will be saved as model.

    Returns:
        str: Resource OpenAPI v3 schema.

    Raises:
        KeyError: If CRD does not have an expected format.
    """
    if len(obj["spec"]["versions"]) > 1:
        logger.warning(
            "CRD contains more than one schema versions. "
            "Script logic should be re-evaluated."
        )

    try:
        # Minimal metadata definition is used for every generated model.
        # Metadata fields are not specified in the source CRD because the current
        # version of kubernetes OpenAPI v3.0 validation schema allows
        # only metadata.name and metadata.generateName fields. Hence,
        # metadata.namespace can not be specified in CRD and should be specified here.
        obj["spec"]["versions"][0]["schema"]["openAPIV3Schema"]["properties"][
            "metadata"
        ] = METADATA_SCHEMA
        return json.dumps(obj["spec"]["versions"][0]["schema"]["openAPIV3Schema"])
    except KeyError as e:
        logger.error(f"CRD does not have an expected format. Key not found: {e}")
        exit(1)


def add_headers(filename: str, headers: tuple = HEADER_MSGS):
    """Add header message to the given file.

    Args:
        filename (str): File which will be updated by headers.
        headers (tuple): Headers to be used.

    """
    with open(filename, "r+") as f:
        content = f.read()
        f.seek(0, 0)
        for header in headers:
            f.write(header.rstrip("\r\n") + "\n")
        f.write("\n" + content)


@click.command(
    context_settings=dict(help_option_names=["-h", "--help"]),
    short_help="Generate pydantic data model from CRDs.",
)
@click.option(
    "--output",
    "-o",
    type=click.Path(exists=True, dir_okay=True, writable=True),
    default=DEFAULT_MODELS_DIR,
    show_default=True,
    help="Path to the output directory.",
)
@click.option(
    "--crd",
    "-c",
    type=click.Path(exists=True),
    default=DEFAULT_CRD_FILE,
    show_default=True,
    help="Path to the custom resource definition file",
)
@click.option(
    "--dry-run",
    "-d",
    type=click.BOOL,
    is_flag=True,
    show_default=True,
    default=False,
    help="Don't save a file to the output, use STDOUT instead.",
)
def model(crd, output, dry_run):
    """Generate pydantic data model from CRDs."""
    objs = get_objs(crd)
    for obj in objs:
        model_path = None if dry_run else get_model_path(obj, output)
        class_name = get_class_name(obj)
        schema = get_schema(obj)

        try:
            generate(
                input_=schema,
                # input_filename=crd,
                output=model_path,
                disable_timestamp=True,
                use_schema_description=True,
                input_file_type=InputFileType.JsonSchema,
                class_name=class_name,
            )
        except DataModelGeneratorError as e:
            logger.error(f"Pydantic data model generator failed: {e}")
            exit(1)

        if not dry_run:
            add_headers(model_path)

        logger.info(
            f"Pydantic data models (with parent model {class_name}) "
            f"have been successfully generated to {model_path or 'STDOUT'}"
        )


if __name__ == "__main__":
    model()
